#include "transx.h"
#include "transxstate.h"

class viewstate
{
	int mfdposition;
	int viewmode;
	int varviewmode;
	int viewfunction,varviewfunction;
	bool switchmode;
	static bool renderviewport;
	bool mfdactive;//If there's an MFD associated with this
	class TransxMFD *imfd;
	viewstate(UINT tmfd,TransxMFD *mfdptr);
	static class transxstate *state;
	static class viewstate *viewstates[20];
	static bool viewstatesinitialised;
	void selfdownshift();
public:
	bool doupdate(HDC hDC,int tw,int th,TransxMFD *mfdptr);
	static bool getviewstate(UINT tmfd,class viewstate **tviewstate,TransxMFD *mfdptr);
	bool getrenderviewport(){return renderviewport;};
	class MFDvariable *GetCurrVariable(); 
	static void preparetoclose();
	static void downshift();
	void setmfdactive(bool temp){mfdactive=temp;};
	void movetonextfunction();
	void movetopreviousfunction();
	void inc_viewmode();
	void togglefunctionswitch(){switchmode=!switchmode;viewfunction=varviewfunction;viewmode=varviewmode;};
	void savecurrent(FILEHANDLE scn);
	void restoresave(FILEHANDLE scn);
	int getvariableviewmode(){return varviewmode;};
	class MFDvarhandler *GetVarhandler();
	void fliphelpsystem();
	static void updatefocusvessel(OBJHANDLE newfocus);
	~viewstate();
};